import requests
import json
from urllib.parse import quote, urlencode
import sys
import time

RED = '\033[91m'
GREEN = '\033[92m'
YELLOW = '\033[93m'
BLUE = '\033[94m'
PURPLE = '\033[95m'
RESET = '\033[0m'


def print_main_menu():
    print(f"{PURPLE}=====XDG·定制服务====={RESET}")
    print(f"{YELLOW}1. {BLUE}🔐 管理员后台{RESET}")
    print(f"{YELLOW}2. {BLUE}🔍 查询卡密到期状态{RESET}")
    print(f"{YELLOW}3. {BLUE}📱 定制版接码{RESET}")
    print(f"{YELLOW}0. {RED}🚪 退出程序{RESET}")


def admin_login():
    print(f"{GREEN}🔐===== 管理员登录 ====={RESET}")
    username = input(f"{BLUE}👤 请输入管理员账号：{RESET}").strip()
    password = input(f"{BLUE}🔑 请输入管理员密码：{RESET}").strip()
    
    user_enc = quote(username)
    pwd_enc = quote(password)
    login_url = f"https://xdgyyds.asia/XDGJM/admin-login.php?username={user_enc}&password={pwd_enc}"
    
    try:
        resp = requests.get(login_url, timeout=10)
        resp.encoding = 'utf-8'
        if "登录成功" in resp.text:
            print(f"{GREEN}✅ 登录成功！{RESET}")
            return username, password
        else:
            print(f"{RED}{resp.text}{RESET}")
            return None, None
    except Exception as e:
        print(f"{RED}❌ 网络错误：{str(e)}{RESET}")
        return None, None


def admin_submenu(admin_user, admin_pass):
    while True:
        print(f"{GREEN}👋====={admin_user}，欢迎回来====={RESET}")
        print(f"{YELLOW}1. {BLUE}➕ 添加管理员{RESET}")
        print(f"{YELLOW}2. {BLUE}🎫 生成卡密{RESET}")
        print(f"{YELLOW}3. {BLUE}🗑️ 删除卡密{RESET}")
        print(f"{YELLOW}4. {BLUE}📋 查看所有卡密{RESET}")
        print(f"{YELLOW}5. {RED}🚪 退出后台{RESET}")
        
        choice = input(f"{BLUE}请选择操作（1-5）：{RESET}").strip()
        if choice == '1':
            _add_admin_user(admin_user, admin_pass)
        elif choice == '2':
            _generate_card(admin_user, admin_pass)
        elif choice == '3':
            _delete_card(admin_user, admin_pass)
        elif choice == '4':
            _list_all_cards(admin_user, admin_pass)
        elif choice == '5':
            print(f"{YELLOW}🚪 退出管理员后台...{RESET}")
            break
        else:
            print(f"{RED}❌ 无效选择，请重新输入！{RESET}")


def _add_admin_user(admin_user, admin_pass):
    new_user = input(f"{BLUE}👤 请输入新管理员账号：{RESET}").strip()
    new_pass = input(f"{BLUE}🔑 请输入新管理员密码：{RESET}").strip()
    
    params = {
        'new_user': new_user,
        'new_pass': new_pass,
        'admin_user': admin_user,
        'admin_pass': admin_pass
    }
    add_url = f"https://xdgyyds.asia/XDGJM/admin-zc.php?{urlencode(params)}"
    
    try:
        resp = requests.get(add_url, timeout=10)
        print(f"{GREEN}添加结果：{resp.text}{RESET}")
    except Exception as e:
        print(f"{RED}❌ 添加失败：{str(e)}{RESET}")


def _generate_card(admin_user, admin_pass):
    print(f"{YELLOW}🎫 卡密类型：{RESET}")
    print(f"{YELLOW}1. {BLUE}⏳ 小时卡（1小时）{RESET}")
    print(f"{YELLOW}2. {BLUE}📅 天卡（24小时）{RESET}")
    print(f"{YELLOW}3. {BLUE}📅 周卡（168小时）{RESET}")
    print(f"{YELLOW}4. {BLUE}📅 月卡（720小时）{RESET}")
    
    card_type = input(f"{BLUE}请选择卡密类型（1-4）：{RESET}").strip()
    hours_map = {'1': 1, '2': 24, '3': 168, '4': 720}
    hours = hours_map.get(card_type)
    
    if not hours:
        print(f"{RED}❌ 无效选择！{RESET}")
        return
    
    params = {
        'hours': hours,
        'admin_user': admin_user,
        'admin_pass': admin_pass
    }
    gen_url = f"https://xdgyyds.asia/XDGJM/admin-sckey.php?{urlencode(params)}"
    
    try:
        resp = requests.get(gen_url, timeout=10)
        resp.encoding = 'utf-8'
        print(f"{GREEN}生成结果：{resp.text}{RESET}")
        import re
        card_match = re.search(r'卡密【(.*?)】', resp.text)
        if card_match:
            print(f"{BLUE}👉 卡密复制：{card_match.group(1)}{RESET}")
    except Exception as e:
        print(f"{RED}❌ 生成失败：{str(e)}{RESET}")


def _delete_card(admin_user, admin_pass):
    card_key = input(f"{BLUE}🎫 请输入要删除的卡密：{RESET}").strip()
    
    params = {
        'admin_user': admin_user,
        'admin_pass': admin_pass,
        'card_key': card_key
    }
    del_url = f"https://xdgyyds.asia/XDGJM/admin-scdkey.php?{urlencode(params)}"
    
    try:
        resp = requests.get(del_url, timeout=10)
        print(f"{GREEN}删除结果：{resp.text}{RESET}")
    except Exception as e:
        print(f"{RED}❌ 删除失败：{str(e)}{RESET}")


def _list_all_cards(admin_user, admin_pass):
    print(f"{GREEN}📋===== 管理员查看所有卡密 ====={RESET}")
    
    params = {
        'admin_user': quote(admin_user),
        'admin_pass': quote(admin_pass)
    }
    list_url = f"https://xdgyyds.asia/XDGJM/admin-listcard.php?{urlencode(params)}"
    
    try:
        resp = requests.get(list_url, timeout=10)
        resp.encoding = 'utf-8'
        print(f"{BLUE}📋 卡密列表：{RESET}")
        print(resp.text)
    except Exception as e:
        print(f"{RED}❌ 查询失败：{str(e)}{RESET}")


def view_card_info():
    print(f"{GREEN}🔍===== 卡密到期查询 ====={RESET}")
    card_key = input(f"{BLUE}🎫 请输入要查询的卡密：{RESET}").strip()
    
    if not card_key:
        print(f"{RED}❌ 卡密不能为空！{RESET}")
        return
    
    params = {'card_key': quote(card_key)}
    check_url = f"https://xdgyyds.asia/XDGJM/check-card.php?{urlencode(params)}"
    
    try:
        resp = requests.get(check_url, timeout=10)
        resp.encoding = 'utf-8'
        print(f"{BLUE}📊 查询结果：{RESET}")
        print(resp.text)
    except Exception as e:
        print(f"{RED}❌ 查询失败：{str(e)}{RESET}")


def custom_receive_code():
    SEARCH_API = "https://xdgyyds.asia/XDGJM/custom-code.php"
    QVK_API = "https://xdgyyds.asia/XDGJM/qvk.php"
    CODE_API = "https://xdgyyds.asia/XDGJM/code.php"
    valid_card = None

    while not valid_card:
        card_key = input(f"{YELLOW}🎫 请输入卡密：{RESET}").strip()
        print(f"{PURPLE}=================={RESET}")
        if not card_key:
            print(f"{RED}❌ 卡密不能为空！{RESET}")
            continue

        test_url = f"{SEARCH_API}?card_key={quote(card_key)}&key=test"
        try:
            resp = requests.get(test_url, timeout=10)
            result = resp.json()
            if result.get("code") == 1:
                valid_card = card_key
                print(f"{GREEN}✅ 卡密验证通过！{RESET}")
            else:
                print(f"{RED}❌ 卡密无效：{result.get('msg', '未知错误')}{RESET}")
        except Exception as e:
            print(f"{RED}❌ 验证失败：{str(e)}{RESET}")

    while True:
        keyword = input(f"{YELLOW}🔍 请输入搜索关键词（输入 q 退出）：{RESET}").strip()
        print(f"{PURPLE}=================={RESET}")
        if keyword.lower() == 'q':
            print(f"{YELLOW}🔐 退出接码系统...{RESET}")
            break
        if not keyword:
            print(f"{RED}❌ 关键词不能为空！{RESET}")
            continue

        search_url = f"{SEARCH_API}?card_key={quote(valid_card)}&key={quote(keyword)}"
        try:
            resp = requests.get(search_url, timeout=10)
            result = resp.json()
        except Exception as e:
            print(f"{RED}❌ 搜索失败：{str(e)}{RESET}")
            continue

        if result.get("code") != 1:
            print(f"{RED}❌ 搜索失败：{result.get('msg', '接口异常')}{RESET}")
            if "卡密" in result.get("msg", ""):
                valid_card = None
                print(f"{RED}❌ 卡密已失效，请重新验证！{RESET}")
                break
            continue

        projects = result.get("data", [])
        if not projects:
            print(f"{RED}📭 未找到相关项目，请换关键词重试！{RESET}")
            continue

        print(f"{BLUE}🔍 关键词「{keyword}」搜索结果（共 {len(projects)} 项）：{RESET}")
        for i, item in enumerate(projects, 1):
            print(f"  {i}. {item.get('name', '未知项目')}")
        print()

        try:
            choice = input(f"{YELLOW}📋 请选择项目序号（回车跳过）：{RESET}").strip()
            print(f"{PURPLE}=================={RESET}")
            if not choice:
                print(f"{YELLOW}↩️ 跳过选择，继续搜索{RESET}")
                continue
            idx = int(choice) - 1
            if 0 <= idx < len(projects):
                selected = projects[idx]
                project_id = selected.get("id")
                print(f"{GREEN}✅ 已选择项目：{selected.get('name', '未知')}{RESET}")
            else:
                print(f"{RED}❌ 无效序号！{RESET}")
                continue
        except:
            print(f"{RED}❌ 无效选择！{RESET}")
            continue

        print(f"{BLUE}⚙️===== 取卡参数配置 ====={RESET}")
        qvk_params = {
            "card_key": valid_card,
            "project_id": project_id
        }

        print("1. 号码模式：")
        print("①指定号码（需输入11位手机号）")
        print("②随机号码")
        choice_phone = input(f"{BLUE}请选择（1/2）：{RESET}").strip()
        print(f"{PURPLE}=================={RESET}")
        while choice_phone not in ["1", "2"]:
            print(f"{RED}❌ 无效选择，请重新输入！{RESET}")
            choice_phone = input(f"{BLUE}请选择（1/2）：{RESET}").strip()
            print(f"{PURPLE}=================={RESET}")
        if choice_phone == "1":
            target_phone = input(f"{BLUE}📱 请输入指定手机号（11位数字）：{RESET}").strip()
            print(f"{PURPLE}=================={RESET}")
            if len(target_phone) == 11 and target_phone.isdigit():
                qvk_params["phone_num"] = target_phone
                print(f"{GREEN}✅ 已设置手机号：{target_phone}{RESET}")
            else:
                print(f"{RED}❌ 手机号格式错误！{RESET}")
                continue

        print("2. 号段模式（选填，不填则跳过）：")
        print("①指定号段（如 170、16511）")
        print("②不指定号段")
        choice_scope = input(f"{BLUE}请选择（1/2，回车跳过）：{RESET}").strip()
        print(f"{PURPLE}=================={RESET}")
        if choice_scope == "1":
            scope = input(f"{BLUE}📞 请输入号段（数字）：{RESET}").strip()
            if scope.isdigit():
                qvk_params["scope"] = scope
                print(f"{GREEN}✅ 已设置号段：{scope}{RESET}")

        print("3. 运营商选择：")
        print("⓪默认\n①移动\n②联通\n③电信\n④实卡⑤虚卡")
        choice_op = input(f"{BLUE}请选择（0-5）：{RESET}").strip()
        print(f"{PURPLE}=================={RESET}")
        if choice_op in ["1", "2", "3", "4", "5"]:
            qvk_params["operator"] = choice_op
            print(f"{GREEN}✅ 已设置运营商：{choice_op}{RESET}")

        print(f"{BLUE}🚀 正在调用取卡接口...{RESET}")
        print(f"{PURPLE}=================={RESET}")
        try:
            resp = requests.get(
                f"{QVK_API}?{urlencode(qvk_params)}",
                timeout=15
            )
            resp.encoding = "utf-8"
            print(f"{GREEN}📱 取卡结果：{RESET}{resp.text}")
            print(f"{PURPLE}=================={RESET}")

            phone_num = resp.text.strip()
            if len(phone_num) == 11 and phone_num.isdigit():
                print(f"{BLUE}✅ 十秒后自动获取验证码请准备好{RESET}")
                time.sleep(10)
            else:
                print(f"{RED}❌ 取卡失败，未获取到有效手机号！{RESET}")
                continue
        except Exception as e:
            print(f"{RED}❌ 取卡失败：{str(e)}{RESET}")
            continue

        print(f"{BLUE}📲=====开始获取验证码====={RESET}")
        success = False
        for attempt in range(10):
            time.sleep(3)
            code_params = {
                "card_key": valid_card,
                "project_id": project_id,
                "phone_num": phone_num
            }
            try:
                resp = requests.get(
                    f"{CODE_API}?{urlencode(code_params)}",
                    timeout=10
                )
                resp.encoding = "utf-8"
                print(f"\r{YELLOW}[尝试 {attempt+1}/10] 响应：{resp.text[:50]}...{RESET}", end=" ")

                try:
                    code_result = resp.json()
                    if code_result.get("code"):
                        print(f"\r{GREEN}✅ {code_result['code']}{RESET}")
                        success = True
                        break
                except:
                    if "验证码" in resp.text:
                        code = resp.text.split("验证码：")[-1].split()[0]
                        print(f"\r{GREEN}✅ {resp.text}{RESET}")
                        success = True
                        break
            except Exception as e:
                print(f"\r{RED}[尝试 {attempt+1}/10] 失败：{str(e)}{RESET}", end=" ")

        if not success:
            print(f"\r{RED}❌ 轮询超时（10次），未获取到验证码{RESET}")
        print()

        continue_flag = input(f"{YELLOW}🔄 是否为当前项目继续取卡？(y/n)：{RESET}").strip()
        if continue_flag.lower() != "y":
            print(f"{YELLOW}↩️ 返回项目搜索{RESET}")


def main():
    while True:
        print_main_menu()
        choice = input(f"{BLUE}请选择功能（0-4）：{RESET}").strip()
        print(f"{PURPLE}=================={RESET}")
        if choice == '1':
            admin_user, admin_pass = admin_login()
            if admin_user and admin_pass:
                admin_submenu(admin_user, admin_pass)
        elif choice == '2':
            view_card_info()
        elif choice == '3':
            custom_receive_code()
        elif choice == '0':
            print(f"{GREEN}😊 感谢使用，程序退出！{RESET}")
            sys.exit(0)
        else:
            print(f"{RED}❌ 无效选择，请输入0-4之间的数字！{RESET}")


if __name__ == "__main__":
    try:
        main()
    except KeyboardInterrupt:
        print(f"{RED}⚠️ 用户强制退出{RESET}")
        sys.exit(0)